import React,{ Component } from 'react';
import style from './index.less';
import GeneralTreat from './GeneralTreat/index.jsx';
import DrugTreat from './DrugTreat/index.jsx';
import TreatDesc from '@components/TreatDesc'
import DrugInfo from '@components/TreatDesc/DrugInfo';
import Notify from '@commonComp/Notify'
import close from './img/close.png';
import generalIcon from './img/general.png';
import surgicalIcon from './img/surgical.png';
import $ from "jquery";

class Treat extends Component {
    constructor(props){
        super(props);
        this.hideTreat = this.hideTreat.bind(this);
        this.handlePrescription = this.handlePrescription.bind(this);
        this.handleDetermine = this.handleDetermine.bind(this);
    }
    componentDidMount(){
        let wrap = document.getElementById('treatWrapper')
        let drag = document.getElementById('dragTreatTitle')
        let width = $(window).width();
        let height = $(window).height();
        let mouseX = 0,mouseY = 0,dragX = 0,dragY = 0,isDrag = false,isMove = false;
        
        let maxDragX = width - wrap.offsetWidth
        let maxDragY = height - wrap.offsetHeight
        drag.onmousedown = (event)=>{    //鼠标位置获取，计算点击位置到拖拽元素左边的距离
          let e = event || window.event;
          mouseX = e.pageX - wrap.offsetLeft
          mouseY = e.pageY - wrap.offsetTop
          isDrag = true
        }
        document.onmousemove = (event)=>{      //移动的
          let e = event || window.event;
          if(isDrag){
            dragX = e.pageX - mouseX
            dragY = e.pageY - mouseY
            if(dragX < 0){      //不能超出左边界
              dragX = 0
            }
            if(dragY < 0){      //不能超出上边界
              dragY = 0
            }
            // if(wrap.offsetLeft >= maxDragX){
            //   dragX = maxDragX
            // }else{
            //   dragX = e.pageX - mouseX
            // }

            // if(height-drag.offsetHeight > wrap.offsetTop){
            //   dragY = height-drag.offsetHeight
            // }
            isMove = true
            wrap.style.left = dragX + 'px'
            wrap.style.marginLeft = 0 + 'px'
            wrap.style.top = dragY + 'px'
          }
        }
        document.onmouseup = ()=>{
          if(isMove){
            wrap.style.left = dragX + 'px'
            wrap.style.top = dragY + 'px'
          }else{
            wrap.style.left = '50%'
            wrap.style.top = '10%'
            wrap.style.marginLeft = '-340px'
          }
          isDrag = false
          return false
        }
    }
    hideTreat() {
        const { hideTreat,clearTreat } = this.props;
        clearTreat && clearTreat();
        hideTreat && hideTreat();
        // document.onmousemove = null
        // document.onmouseup = null
    }
    handlePrescription() {
        Notify.info('该功能即将上线，敬请期待。', 2000)
    }
    handleDetermine() {
        const { title, treatment, advice } = this.props
        const { addScheme } = this.props
        addScheme && addScheme(title, treatment);
        this.hideTreat()
    }
    showDrugInfo() {
        const {  showDrugInfo } = this.props;
        showDrugInfo && showDrugInfo();
    }

    render(){
        const { generalTreat, treatment, treatItem, surgeryTreat, selectDrug, drugInfo, treatDesc, setOtherRecommend, setDrugInfo, showDrug, showDrugInfo,hideDrugInfo, title, drugInfoList, hideDrugInfoMore} = this.props;
        const { setDrugInfoMore } = this.props
        return(
            <div   className={style['treat-wrapper']}>
                <div className={style['treat-mask']} onClick={this.hideTreat}>
                </div>
                <div id="treatWrapper" className={style['treat-box']}  onselectstart="return false">
                    <div id="dragTreatTitle" className={style['treat-title']}>治疗方案 ({treatItem.name})<img onClick={this.hideTreat} src={close}/></div>

                    <div className={style['treat-inner-box']}>
                        <GeneralTreat icon={generalIcon} title='一般治疗'   generalTreat={generalTreat}></GeneralTreat>
                        <DrugTreat treatment={ treatment } 
                                selectDrug={selectDrug} 
                                setOtherRecommend={ setOtherRecommend } 
                                showDrugInfo = {showDrugInfo}
                                setDrugInfo={ setDrugInfo }
                                setDrugInfoMore = {setDrugInfoMore} //查询多条药品说明数据
                            >
                        </DrugTreat> 
                        <GeneralTreat icon={surgicalIcon} title='手术治疗' titleStyle={{background:'#FAEAEA',opacity:'1', filter:'alpha(opacity=100);',filter:'progid:DXImageTransform.Microsoft.Alpha(opacity=100);'}} titleBg='#FAEAEA' generalTreat={surgeryTreat}></GeneralTreat>
                    </div>
                    <div className={style['bottom']}>
                        <span className={style['prescription-btn']} onClick={this.handlePrescription}>开处方</span> <span className={style['determine-btn']} onClick={this.handleDetermine}>确定</span>
                    </div>
                    {treatDesc && <TreatDesc 
                    treatment={treatment} 
                    treatDesc={treatDesc} 
                    selectDrug={selectDrug} 
                    setDrugInfo={ setDrugInfo } 
                    showDrugInfo = {showDrugInfo}
                    showDrug = {showDrug}
                    >
                    </TreatDesc>}
                </div>
                
                
                {showDrug && drugInfo && <DrugInfo drugInfo = {drugInfo} hideDrugInfo = {hideDrugInfo}></DrugInfo>}
                {/* 查询多个药品说明书 （添加数据查看药品说明书用）*/}
                {/* {showDrug && <DrugInfo drugInfoList = {drugInfoList} hideDrugInfoMore = {hideDrugInfoMore}></DrugInfo>} */}
            </div>
                
            
        
        )
    }
}

export default Treat;
